﻿using System.Windows;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace Post11459
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        bool showLabel = false;


        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer layer = new ShapeFileFeatureLayer(@"YourPath");

            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(144186));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(72000));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(36000));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(18000));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(9000));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(4500));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(2250));
            layer.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(1125));

            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(144186));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(72000));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(36000));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(18000));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(9000));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(4500));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(2250));
            wpfMap1.ZoomLevelSet.CustomZoomLevels.Add(new ZoomLevel(1125));

            TextStyle currentTextStyle = null;

            SetTextStyle(layer, currentTextStyle);

            ManagedProj4Projection proj4 = new ManagedProj4Projection();
            proj4.InternalProjectionParametersString = ManagedProj4Projection.GetGoogleMapParametersString();
            proj4.ExternalProjectionParametersString = ManagedProj4Projection.GetDecimalDegreesParametersString();

            proj4.Open();

            layer.FeatureSource.Projection = proj4;

            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(layer);
            wpfMap1.Overlays.Add(overlay);

            //layer.Open();
            //wpfMap1.CurrentExtent = layer.GetBoundingBox();
            //layer.Close();

            wpfMap1.CurrentExtent = new RectangleShape(-111.243320736213, 53.1528078163572, -110.089756283088, 52.4469362343259);

            wpfMap1.CurrentScale = 144186;

            wpfMap1.Refresh();
        }

        private static void SetTextStyle(ShapeFileFeatureLayer layer, TextStyle currentTextStyle)
        {
            layer.ZoomLevelSet.CustomZoomLevels[0].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[0].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[0].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[1].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[1].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[1].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[2].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[2].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[2].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[3].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[3].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[3].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[4].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[4].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[4].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[5].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[5].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[5].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[6].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[6].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[6].DefaultTextStyle = currentTextStyle;

            layer.ZoomLevelSet.CustomZoomLevels[7].DefaultAreaStyle = AreaStyles.Country1;
            layer.ZoomLevelSet.CustomZoomLevels[7].DefaultLineStyle = LineStyles.LocalRoad4;
            layer.ZoomLevelSet.CustomZoomLevels[7].DefaultTextStyle = currentTextStyle;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            showLabel = !showLabel;

            TextStyle currentTextStyle = null;
            button1.Content = "Show Label";

            if (showLabel)
            {
                currentTextStyle = new TextStyle("NAME", new GeoFont("Arial", 11), new GeoSolidBrush(GeoColor.StandardColors.Black));
                currentTextStyle.TextLineSegmentRatio = 4;
                currentTextStyle.Mask = null;
                currentTextStyle.BestPlacement = true;
                currentTextStyle.SuppressPartialLabels = true;
                currentTextStyle.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels;
                currentTextStyle.OverlappingRule = LabelOverlappingRule.AllowOverlapping;
                currentTextStyle.GridSize = 40;

                button1.Content = "Hide Label";
            }

            SetTextStyle(((LayerOverlay)wpfMap1.Overlays[0]).Layers[0] as ShapeFileFeatureLayer, currentTextStyle);

            wpfMap1.Refresh();
        }
    }
}
